
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#include "LIBRTMutex.h"



int LIBRT_MUTEX_Crear (LIBRT_MUTEX *m)
{
#if defined(WIN32)
	*m = CreateMutex (NULL, 0, NULL);

	if ( *m == NULL )
		return 0;
	else
		return 1;
#elif defined(LINUX)
	pthread_mutex_init(m, NULL);
	return 1;
#endif
}



int LIBRT_MUTEX_Destruir(LIBRT_MUTEX m)
{

#if defined(WIN32)
	return CloseHandle(m);
#elif defined(LINUX)
	if ( pthread_mutex_destroy(&m) != 0 )
	  return 0;
	else
	  return 1;
#endif

}



int LIBRT_MUTEX_Lock (LIBRT_MUTEX m)
{
#if defined(WIN32)
	if ( WaitForSingleObject(m, LIBRT_MUTEX_TIMEOUT) == WAIT_FAILED ) {
		return 0;
	} else {
		return 1;
	}
#elif defined(LINUX)
	if ( pthread_mutex_lock(&m) != 0 )
	  return 0;
	else
	  return 1;
#endif
}


int LIBRT_MUTEX_Unlock (LIBRT_MUTEX m)
{
#if defined(WIN32)
	if ( ReleaseMutex(m) == 0 ) {
		return 0;
	} else {
		return 1;
	}
#elif defined(LINUX)
	if (pthread_mutex_unlock(&m) != 0 )
	  return 0;
	else
	  return 1;
#endif
}
