
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#ifndef __BLOCK_H__
#define __BLOCK_H__

#include <stdio.h>
#include <blocktypes.h>

#include "err.h"


enum object_mode {
	MODE_CIPHERED,
	MODE_CLEAR,
	MODE_EMPTY,
	MODE_ERR
};
typedef enum object_mode object_mode_t;

/* A generic block */

int BLOCK_OBJECT_New       ( block_object_t **block );
int BLOCK_OBJECT_Free      ( block_object_t *block );
int BLOCK_OBJECT_Delete    ( block_object_t *block );
int BLOCK_OBJECT_New_Empty ( block_object_t *ob );

object_mode_t BLOCK_OBJECT_Get_Mode ( block_object_t *ob );

int BLOCK_OBJECT_Cipher   ( block_object_t *ob, char *pwd, block_info_t *ib );
int BLOCK_OBJECT_Decipher ( block_object_t *ob, char *pwd, block_info_t *ib );

void BLOCK_PRINT_InfoBlock   ( block_info_t *block, FILE *fp );
void BLOCK_PRINT_ObjectBlock ( block_object_t *block, FILE *fp);

#endif
