
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#ifndef _CERTIFICADO_X509_H_
#define _CERTIFICADO_X509_H_ 1

#include "pkcs11.h"
#include "certif.h"
#include "common.h"

class CertificadoX509 : public Certificado
{
 public:
    CertificadoX509(void);		// Constructor -sobrecargado-
    CertificadoX509(CK_ATTRIBUTE_PTR pTemplate, CK_ULONG ulCount, unsigned char * certId);	// Constructor
    ~CertificadoX509(void);		// Destructor
    void copiarObjeto(CertificadoX509 *pNuevoObjeto);
    CK_RV modificarObjeto(CK_ATTRIBUTE_PTR pTemplate, CK_ULONG ulCount);
    void volcarPlantilla(CK_ATTRIBUTE_PTR pTemplate, CK_ULONG ulMaxCount, CK_ULONG &ulCount);
    unsigned int numeroAtributos(void);

    CK_BYTE *get_subject (void);
    CK_BYTE *get_id (void);
    CK_BYTE *get_issuer (void);
    CK_BYTE *get_serial_number (void);
    CK_BYTE *get_value (void);
	unsigned char * get_certId(void);
 protected:
    // Por cada atributo tenemos otro con el mismo nombre, pero con
    // el prefijo 'tam', que guarda el tamano del objeto apuntado
    // por el atributo pareja.

    CK_BYTE *subject;
    CK_ULONG tamSubject;

    CK_BYTE *id;
    CK_ULONG tamId;

    CK_BYTE *issuer;
    CK_ULONG tamIssuer;
	
    CK_BYTE *serial_number;
    CK_ULONG tamSerial_number;
	
    CK_BYTE *value;
    CK_ULONG tamValue;
	unsigned char _certId[CERT_ID_LEN];

};

// Metodos get

inline unsigned char *CertificadoX509::get_certId(void)
{
	return _certId;
}

inline CK_BYTE *CertificadoX509::get_subject (void)
{
    return subject;
}

inline CK_BYTE *CertificadoX509::get_id (void)
{
    return id;
}

inline CK_BYTE *CertificadoX509::get_issuer (void)
{
    return issuer;
}

inline CK_BYTE *CertificadoX509::get_serial_number (void)
{
    return serial_number;
}

inline CK_BYTE *CertificadoX509::get_value (void)
{
    return value;
}

#endif
