
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#include "common.h"
#ifdef WIN32
#include "windows.h"
#endif

#ifdef LOG
#include "log.h"
#endif 

// La funcion relleno hace una copia de una cadena y
// realiza un relleno con espacios hasta que la cadena tenga
// la longitud que indique el parametro longitudConRelleno
char * padding(char *destino, char *origen, unsigned int longitudConRelleno)
{
    unsigned int i;

    //Copiamos la cadena origen a la cadena destino
    for(i = 0; i < strlen(origen); i++)
	destino[i] = origen[i];
    //Completamos con espacios
    for(; i < longitudConRelleno; i++)
	destino[i] = ' ';
    //Nota: la cadena queda sin marcar

    return destino;

}


CK_ATTRIBUTE_PTR buscarEnPlantilla(CK_ATTRIBUTE_PTR pTemplate, CK_ULONG ulCount, CK_ATTRIBUTE_TYPE type)
{
    unsigned long contador;

    contador = 0;

    //LOG_Debug(LOG_TO, "buscando en plantilla el tipo: %02x", type);

    while(contador < ulCount)
        {
	    if (pTemplate[contador].type == type){
		//LOG_Msg(LOG_TO, "Tipo encontrado !!!");
		return &pTemplate[contador];
	    }
	    else
		contador++;
        }
    return NULL_PTR;
}


// La funcion destruirPlantilla libera la memoria que se alojo
// para la plantilla
void destruirPlantilla(CK_ATTRIBUTE_PTR pTemplate, CK_ULONG ulCount)
{
    unsigned int contador;

    for (contador = 0; contador < ulCount; contador++)
	if(pTemplate[contador].pValue)
	    free(pTemplate[contador].pValue);
    free(pTemplate);
}

// From clauer-utils
void SMEM_Destroy ( void *buf, unsigned long size )
{
    volatile unsigned char *i_buf = ( volatile unsigned char * ) buf;
    register unsigned long i = size;

    while ( i-- ) {
        *i_buf = 0;
        *i_buf = 0xaa;
        *i_buf = 0x55;
        *(i_buf++) = 0;
    }
}





// Languaje on windows
//1034 espaol
//1027 catala
//otro ingles
DWORD IDIOMA_Obtener (void)
{
#ifdef WIN32
    HKEY hKey;
    DWORD tamValue;
    char * idioma;
    DWORD res;
    
    res = EN;
        
    if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE,
		      "SOFTWARE\\Universitat Jaume I\\Projecte Clauer",
		      0,
		      KEY_QUERY_VALUE,
		      &hKey) != ERROR_SUCCESS )
        {
	    //			LOG_MsgError(LOG_TO, "Error 2");   
	    return res;
        }
    
    if ( RegQueryValueEx(hKey,"Idioma", NULL, NULL, NULL, &tamValue) != ERROR_SUCCESS ) {
	RegCloseKey(hKey);
	//				LOG_MsgError(LOG_TO, "Error 3");   
	return res;
    }
    
    if ( tamValue > 5 ) {
	RegCloseKey(hKey);
	//				LOG_MsgError(LOG_TO, "Error 4");   
	return res;
    }
    
    idioma = new char [tamValue];
    
    if ( !idioma ) {
	RegCloseKey(hKey);
	//				LOG_MsgError(LOG_TO, "Error 5");   
	return res;
    }
    
    if ( RegQueryValueEx(hKey,"Idioma", NULL, NULL, (BYTE *)idioma,
			 &tamValue) != ERROR_SUCCESS ) {
	delete [] idioma;
	idioma = NULL;
	RegCloseKey(hKey);
	//				LOG_MsgError(LOG_TO, "Error 6");   
	return res;
    }
    
    RegCloseKey(hKey);
    
    if ( strncmp(idioma,"1034",4) == 0) 
	return ES;
    else if ( strncmp(idioma,"1027",4) == 0 )
	return CA;
    
    return res;
    
#else 
    return ES;
#endif        
}
