
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#ifndef _LOBJETO_H_
#define _LOBJETO_H_ 1


#include "pkcs11.h"
#include "objeto.h"

#ifdef DEBUG
#include "log.h"
#endif

//----------------------------------------------------------------
//------------------------nodoObjeto------------------------------
//----------------------------------------------------------------

class nodoObjeto
{
 public:
    nodoObjeto(Objeto *valor);	//Constructor
    ~nodoObjeto(void);			//Destructor

    void set_sig(nodoObjeto *valor);
    nodoObjeto *get_sig(void);
	
    void set_ant(nodoObjeto *valor);
    nodoObjeto *get_ant(void);
	
    void set_objeto(Objeto *valor);
    Objeto *get_objeto(void);
 protected:
    nodoObjeto *sig;
    nodoObjeto *ant;
    Objeto *pObjeto;
	

};

// Metodos set y get
inline void nodoObjeto::set_sig(nodoObjeto *valor)
{
    sig = valor;
}

inline nodoObjeto *nodoObjeto::get_sig(void)
{
    return sig;
}
	
inline void nodoObjeto::set_ant(nodoObjeto *valor)
{
    ant = valor;
}

inline nodoObjeto *nodoObjeto::get_ant(void)
{
    return ant;
}

inline void nodoObjeto::set_objeto(Objeto *valor)
{
    pObjeto = valor;
}

inline Objeto *nodoObjeto::get_objeto(void)
{
    return pObjeto;
}
//----------------------------------------------------------------
//------------------------listaObjetos----------------------------
//----------------------------------------------------------------

class listaObjetos
{
 public:
    listaObjetos(void);
    ~listaObjetos(void);

    void insertarObjeto(Objeto *valor);
    void deleteAllObjects(void);
    void eliminarObjeto(Objeto *valor);
    Objeto *buscarObjeto(CK_OBJECT_HANDLE valor);
	
    void iniciarBusquedaPlantilla(CK_ATTRIBUTE_PTR pPlantilla, CK_ULONG numeroAtributos);
    void iniciarBusqueda(void);   
    CK_OBJECT_HANDLE buscarPlantilla(void);
    void finalizarBusquedaPlantilla(void);
    CK_BBOOL estaBusquedaIniciada(void);

    void avanzar(void);
    int  esFin(void);
    Objeto *elementoActual(void);
	
	
 protected:
    CK_ATTRIBUTE_PTR pPlantillaBusqueda;
    CK_ULONG plantillaNumeroAtributos;
    CK_BBOOL busquedaIniciada;
    nodoObjeto *cabeceraListaObjetos;
    nodoObjeto *cursor;
    int _contador;
	
};

inline CK_BBOOL listaObjetos::estaBusquedaIniciada(void)
{
    return busquedaIniciada;
}

#endif
