
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

/*
 * Description: Contains the functions related to the Mechanism 
 *              associated with clauer token. 
 * 
 * Notes: Windows code is not been implemented yet. 
 *  
 * 
 *                         Clauer Team 2006 
 **/               


#ifndef __MECNISM_H__
#define __MECNISM_H__ 

#include "pkcs11.h"

// Key sizes
#define MIN_KEY_SIZE 1024 
#define MAX_KEY_SIZE 4096

class Mechanism 
{
 public:
    Mechanism(CK_MECHANISM_TYPE _type, CK_ULONG _ulMinKeySize, CK_ULONG _ulMaxKeySize, CK_FLAGS _flags);
    ~Mechanism(void);	// Destructor
    CK_RV C_GetMechanismInfo(CK_MECHANISM_INFO_PTR pInfo);
  
    CK_MECHANISM_TYPE get_type (void);
    CK_ULONG get_ulMinKeySize (void);
    CK_ULONG get_ulMaxKeySize (void);
    CK_FLAGS get_flags (void);
  
 protected:
    CK_MECHANISM_TYPE type;
    CK_ULONG ulMinKeySize;
    CK_ULONG ulMaxKeySize;
    CK_FLAGS flags;
};
// Metodos get
inline CK_MECHANISM_TYPE Mechanism::get_type (void)
{
    return type;
}

inline CK_ULONG Mechanism::get_ulMinKeySize (void)
{
    return ulMinKeySize;
}

inline CK_ULONG Mechanism::get_ulMaxKeySize (void)
{
    return ulMaxKeySize;
}

inline CK_FLAGS Mechanism::get_flags (void)
{
    return flags;
}

#endif
