
/*

                        LICENCIA

1. Este programa puede ser ejecutado sin ninguna restriccin
   por parte del usuario final del mismo.

2. La  Universitat Jaume I autoriza la copia y  distribucin
   del programa con cualquier fin y por cualquier medio  con
   la  nica limitacin de que, de forma  apropiada, se haga
   constar  en  cada  una  de las copias la  autora de esta  
   Universidad  y  una reproduccin  exacta de las presentes 
   condiciones   y   de   la   declaracin  de  exencin  de 
   responsabilidad.

3. La  Universitat  Jaume  I autoriza  la  modificacin  del
   software  y  su  redistribucin  siempre que en el cambio
   del  cdigo  conste la autora de la Universidad respecto  
   al  software  original  y  la  url de descarga del cdigo
   fuente  original. Adems, su denominacin no debe inducir 
   a  error  o  confusin con el original. Cualquier persona
   o  entidad  que  modifique  y  redistribuya  el  software 
   modificado deber  informar de tal circunstancia mediante
   el  envo  de  un  mensaje  de  correo  electrnico  a la 
   direccin  clauer@uji.es  y  remitir una copia del cdigo 
   fuente modificado.

4. El  cdigo  fuente  de todos los programas amparados bajo 
   esta licencia  est  disponible para su descarga gratuita
   desde la pgina web http//:clauer.uji.es.

5. El hecho en s del uso, copia o distribucin del presente 
   programa implica la aceptacin de estas condiciones.

6. La  copia y distribucin del programa supone la extensin 
   de las presentes condiciones al destinatario.
   El  distribuidor no puede imponer condiciones adicionales
   que limiten las aqu establecidas.

       DECLARACIN DE EXENCIN DE RESPONSABILIDAD

Este  programa  se  distribuye  gratuitamente. La Universitat 
Jaume  I  no  ofrece  ningn  tipo de garanta sobre el mismo
ni acepta ninguna responsabilidad por su uso o  imposibilidad
de uso.

*/

#ifndef __THREADS_H__
#define __THREADS_H__

#ifdef LINUX
#include <pthread.h>
#include <unistd.h>
#elif defined(WIN32)
#include <windows.h>
#endif

#include <stdlib.h>
#include <stdio.h>

#include "common.h"


#ifdef WIN32
#include <map>
#include <string>
struct PASS_CACHE_INFO {
    char pass[128];             // the password null terminated
    char id[20];             // the privkey id
    int ttl;              // time stamp. Indicates the last time the password was requested
};
#endif

using namespace std;

typedef struct ID_ACCESS_HANDLE {
#ifdef LINUX
    pthread_mutex_t clauerIdMutex; // Mutex that protects newClauerId
#elif defined(WIN32)
    HANDLE clauerIdMutex;
    HANDLE keyIdMutex;
    map<string, PASS_CACHE_INFO *> keyCache;
    int global_pass_ttl;
#endif
    unsigned char newClauerId[CLAUER_ID_LEN];
} ID_ACCESS_HANDLE;

#ifdef LINUX
void * updateIdThread(void * ptr);
#elif defined(WIN32)
DWORD WINAPI updateIdThread(void *ptr);
#endif

#endif
